# The Rocket Programming Guide

Welcome to Rocket!

This is the official guide for Rocket v0.4. It is designed to serve as a
starting point to writing web applications with Rocket and Rust. The guide is
also designed to be a reference for experienced Rocket developers. This guide is
conversational in tone. For purely technical documentation with examples, see
the [API documentation](@api).

The guide is split into several sections, each with a focus on a different
aspect of Rocket. The sections are:

   - **[Introduction](introduction/):** introduces Rocket and its philosophy.
   - **[Quickstart](quickstart/):** presents the minimal steps necessary to
      run your first Rocket application.
   - **[Getting Started](getting-started/):** a gentle introduction to getting
     your first Rocket application running.
   - **[Overview](overview/):** describes the core concepts of Rocket.
   - **[Requests](requests/):** discusses handling requests: control-flow,
     parsing, and validating.
   - **[Responses](responses/):** discusses generating responses.
   - **[State](state/):** how to manage state in a Rocket application.
   - **[Fairings](fairings/):** provides an overview of Rocket's structured
     middleware.
   - **[Testing](testing/):** how to unit and integration test a Rocket
     application.
   - **[Configuration](configuration/):** how to configure a Rocket application.
   - **[Pastebin](pastebin/):** a tutorial on how to create a pastebin with
     Rocket.
   - **[Conclusion](conclusion/):** concludes the guide and discusses next steps
     for learning.

## Getting Help

The official community support channels are the `#rocket` IRC channel on the
[Mozilla IRC Server](https://wiki.mozilla.org/IRC) at `irc.mozilla.org` and the
bridged [Rocket room on
Matrix](https://riot.im/app/#/room/#mozilla_#rocket:matrix.org). If you're not
familiar with IRC, we recommend chatting through [Matrix via
Riot](https://riot.im/app/#/room/#mozilla_#rocket:matrix.org) or via the [Kiwi
web IRC client](https://kiwiirc.com/client/irc.mozilla.org/#rocket). You can
learn more about IRC via Mozilla's [Getting Started with
IRC](https://developer.mozilla.org/en-US/docs/Mozilla/QA/Getting_Started_with_IRC)
guide.
